﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data.OleDb; //Database connectivity

public partial class StudentDatabaseMain : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        //Create the connection while loading the form
        OleDbConnection StudentConnection = new OleDbConnection();
        StudentConnection.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data source=";
        StudentConnection.ConnectionString += Server.MapPath("StudentDatabase.mdb");
        //Add it to the application Object for future use
        Application.Add("Connection", StudentConnection);
    }

    private bool AddStudentToTheDatabase()
    {
        try
        {
            //Get the connection to read already stored database ..
            OleDbConnection StudentConnection = (OleDbConnection)Application["Connection"];
            //Open the connection now 
            StudentConnection.Open();
            //Iterate the list and insert the names
            foreach (ListItem StudentItem in ListBoxStudents.Items)
            {
                string myAddQuery = "INSERT INTO STUDENT_INFO (StudentName) VALUES('" + StudentItem.Text + "')";
                OleDbCommand StudentCommand = new OleDbCommand(myAddQuery, StudentConnection);
                //Ececute the Query
                StudentCommand.ExecuteNonQuery();
            }
            StudentConnection.Close();
            return true;
        }
        catch (Exception Ex)
        {
            Response.Write(Ex.Message);
            return false;
        }
    }

    protected void btnAddStudent_Click(object sender, EventArgs e)
    {
        //Add the student directly to the list in the main page
        ListBoxStudents.Items.Add(TextBoxName.Text);
    }

    protected void btnDeleteStudent_Click(object sender, EventArgs e)
    {
        //Delete the student directly to the list in the main page
        ListBoxStudents.Items.Remove(ListBoxStudents.SelectedItem);
    }

    protected void btnSaveAllStudents_Click(object sender, EventArgs e)
    {
        AddStudentToTheDatabase();
    }

    protected void btnShowAllStudents_Click(object sender, EventArgs e)
    {
        //Remove all items from the List
        ListBoxStudents.Items.Clear();
        //Get the connection
        OleDbConnection StudentConnection = (OleDbConnection)Application["Connection"];
        try
        {
            //Open the connection
            StudentConnection.Open();
            //Run the selecet SQL Query
            string mySelectQuery = "SELECT * FROM STUDENT_INFO";
            OleDbCommand StudentCommand = new OleDbCommand(mySelectQuery, StudentConnection);
            //Execute the Query and get all datas in the data reader
            OleDbDataReader StudentDescReader = StudentCommand.ExecuteReader();
            //Clear the array first
            //Iterate it and fill it to the list
            while (StudentDescReader.Read())
            {
                ListBoxStudents.Items.Add(StudentDescReader.GetValue(StudentDescReader.GetOrdinal("StudentName")).ToString());
            }
        }
        catch (Exception Ex)
        {
            Response.Write(Ex.Message);
            return;
        }

    }
}